/**   
 * @Package     : com.ccb.mobile.platform
 * @Copyright   : @版权所有 中国建设银行版权所有
 * @Description : TODO(用一句话描述该文件做什么)
 * Administrator   
 * 2014-4-16
 * @version     : v1.0   
 */

package com.ccb.mobile.platform;

import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import android.content.Context;
import android.content.SharedPreferences;

import com.ccb.mobile.platform.actionflow.CallFilterFlow;
import com.ccb.mobile.platform.actionflow.CallISO_GBK;
import com.ccb.mobile.platform.actionflow.OperationFlow;
import com.ccb.mobile.platform.bean.AppInfo;
import com.ccb.mobile.platform.bean.SYS_TXATTR;
import com.ccb.mobile.platform.db.DBUtil;
import com.ccb.mobile.platform.exception.NetworkException;
import com.ccb.mobile.platform.exception.ParseDataException;
import com.ccb.mobile.platform.http.HttpClient;
import com.ccb.mobile.platform.system.B2BSystem;
import com.ccb.mobile.platform.system.B2CSystem;
import com.ccb.mobile.platform.system.BaseSystem;
import com.ccb.mobile.platform.system.CCBSystem;
import com.ccb.mobile.platform.system.JSSystem;
import com.ccb.mobile.platform.system.MBSSystem;
import com.ccb.mobile.platform.system.PICSystem;
import com.ccb.mobile.platform.system.VersionManageSystem;
import com.ccb.mobile.platform.threadpool.Platform_ThreadPools;
import com.ccb.mobile.platform.utils.MbsLogManager;
import com.ccb.mobile.platform.utils.PlatformUtils;

/**
 * 逻辑层处理核心类
 * 
 * @ClassName : PlatformManager
 * @author : LiangYJ
 * @date : 2014-4-16
 * 
 */
public class PlatformManager {
  private static PlatformManager mManager;
  protected AppInfo mAppInfo;
  protected Context mContext;
  // protected HashMap<String, String> mParamsMap;
  protected String mTxcode;
  protected DBUtil mDB;
  protected HashMap<String, String> mSysParas;
  protected HashMap<String, SYS_TXATTR> sys_TXATTR_map;
  protected SYS_TXATTR mSYS_TXATTR;

  protected HashMap<String, String> localResponse;// 本地档板文件
  private static byte[] lock = new byte[0];

  private PlatformManager() {
  }

  /**
   * 
   * 获取逻辑层处理类
   */
  protected static PlatformManager getInstance() {
    if (mManager == null) {
      mManager = new PlatformManager();
    }
    return mManager;
  }

  /**
   * 
   * 逻辑层获取数据
   * 
   * @param context
   *          上下文
   * @param params
   *          请求参数
   * @return Object: 返回类型
   */
  protected Object doFetch(Context context, HashMap<String, String> params, String channel_url) {
    // 获取
    if (mManager.mAppInfo == null) {
      mManager.mAppInfo = AppInfo.getAppInfo(context);
      BaseSystem.mAppInfo = mManager.mAppInfo;
    }
    mManager.mContext = context;
    // mManager.mParamsMap = params;
    synchronized (lock) {
	    if (mManager.mDB == null) {
	      MbsLogManager.logD("init DB....");
	      mManager.mDB = new DBUtil(context);
	      mSysParas = mManager.mDB.iniSys_paras();
	      sys_TXATTR_map = mManager.mDB.iniSys_txattrs();
	    }
	}
    
    // 获取txcode的值
    final String TXCODE = "txcode";
    Iterator<String> keys = params.keySet().iterator();
    String key = null;
    String value = null;// TXCODE
    while (keys.hasNext()) {
      key = keys.next();
      if (TXCODE.equalsIgnoreCase(key)) {
        value = params.get(key);
        break;
      }
    }

    final String txcode = (mManager.mTxcode = value);
    BaseSystem<Object> sys = null;
    Object mResult = null;
    String mChannelType = null;
    String mPackageType = null;
    boolean isCallIso_Gbk = false;// 检查交易返回值是否需要转码：ISO-8859-1转成GBK
    String chartSet = null;// 发送请求的字符编码格式

    // 通过txcode取得数据库相关数据
    if (mManager.mTxcode != null) {
      mSYS_TXATTR = sys_TXATTR_map.get(mManager.mTxcode);
      mChannelType = mSYS_TXATTR.getChannelType();
      mPackageType = mSYS_TXATTR.getPakageType();// 返回结果类型

      OperationFlow flow = new OperationFlow(mSYS_TXATTR);
      HashMap<String, Class> actionBefores = flow.getActionBefore_Map();
      if (actionBefores.size() > 0) {
        for (String action : actionBefores.keySet()) {
          if (action.equalsIgnoreCase("CallFilterFlow")) {
            CallFilterFlow filterFlow = new CallFilterFlow();
            params = filterFlow.excute(params);
          }
        }
      }
      HashMap<String, Class> actionAfters = flow.getActionAfter_Map();
      if (actionAfters.size() > 0) {
        for (String action : actionAfters.keySet()) {
          if (action.equalsIgnoreCase("CallISO_GBK")) {
            CallISO_GBK iso_gbk = new CallISO_GBK();
            isCallIso_Gbk = iso_gbk.excute();
          }
        }
      }

    } else {
      // 没有交易码的链接，分为js、获取图片、版本更新 三种类型
      mSYS_TXATTR = null;
      //增加支持断点续传
      int check_result = PlatformUtils.checkNoTxcodeType(params);
      if (1 == check_result) {
        mChannelType = Constants.CHANNEL_TYPE_PIC;
      } else if(2 == check_result){
    	  mChannelType = Constants.CHANNEL_TYPE_APPVERSION;
      }else {
        mChannelType = Constants.CHANNEL_TYPE_JS;
      }
    }

    // 通过txcode取得对应的系统
    try {
      if (mChannelType.equals(Constants.CHANNEL_TYPE_0)) {
        // 个人网银
        // sys = new B2CSystem(context, params);
        sys = B2CSystem.getB2CSystem(context, params);
      } else if (mChannelType.equals(Constants.CHANNEL_TYPE_1)) {
        // 企业网银
        // sys = new B2BSystem(context, params);
        sys = B2BSystem.getB2BSystem(context, params);
      } else if (mChannelType.equals(Constants.CHANNEL_TYPE_2)) {
        // 手机银行
        sys = MBSSystem.getMBSSystem(context, params);
      } else if (mChannelType.equals(Constants.CHANNEL_TYPE_3)) {
        // 网站
        // sys = new CCBSystem(context, params);
        sys = CCBSystem.getCCBSystem(context, params);
      } else if (mChannelType.equals(Constants.CHANNEL_TYPE_JS)) {
        // 无交易码请求交易 JS
        // sys = new No_TxcodeSystem(context, params);
        // System.out.println("初始化JSsystm:"+Thread.currentThread().getId()+"--"+params);
        sys = JSSystem.getJSSystem(context, params);
      } else if (mChannelType.equals(Constants.CHANNEL_TYPE_PIC)) {
        // 无交易码请求交易 pic
        // sys = new PICSystem(context, params);
        sys = PICSystem.getPicSystem(context, params);
      } else if(mChannelType.equals(Constants.CHANNEL_TYPE_APPVERSION)){
    	  //断点续传
    	 sys = VersionManageSystem.getVersionManageSystem(context, params);
      }else {
        // 默认
      }

      // if(channel_url == null){
      // sys.setBaseUrl("");
      // }else{
      // sys.setBaseUrl(mSysParas.get(channel_url));
      // }

      if (mSYS_TXATTR != null) {
        MbsLogManager.logD("#PlatfromManager# doFetch#" + mSYS_TXATTR.toString());
      }

      // 某些遗留交易，如悦生活或企业网银，页面编码UTF-8转为GBK，内容则为ISO-8859-1
      // 判断当前交易返回结果是否需要做UTF-8转GBK
      // if(callIso_Gbk){
      // sys.setResposeEncode(true);
      // }else{
      // sys.setResposeEncode(false);
      // }

      // 交易的请求和应答的编码格式正常是一致的。
      // 设置请求和应答的编码格式为交易配置表信息，如果未配置交易，如图片和js则为UTF-8编码或可按照系统类型进行改造
      // sys.setEncoding(mSYS_TXATTR==null?HttpClient.UTF_8:mSYS_TXATTR.getCharacterEncoding());
      chartSet = mSYS_TXATTR == null ? HttpClient.UTF_8 : mSYS_TXATTR.getCharacterEncoding();

      if (mChannelType.equals(Constants.CHANNEL_TYPE_PIC)) {
        // System.out.println("交易请求前参数："+Thread.currentThread().getId()+"--"+params);
        mResult = (Object) sys.request_Bitmap(channel_url == null ? "" : mSysParas.get(channel_url), params);
      } else if(mChannelType.equals(Constants.CHANNEL_TYPE_APPVERSION)){
    	 mResult = (Object)sys.request_VersionManage(channel_url == null ? "" : mSysParas.get(channel_url), params);
      }else{
        mResult = (Object) sys.request_String(channel_url == null ? "" : mSysParas.get(channel_url), params, chartSet, isCallIso_Gbk);
      }
      // 支持应答报文为XML格式
      // if(mPackageType != null && "XML".equalsIgnoreCase(mPackageType)){
      // mResult =
      // "<?xml version=\"1.0\" encoding=\"utf-8\"?><DOCUMENT><BODY><SUCCESS>true</SUCCESS><COOKIES>wexsdsdsdw20001</COOKIES><cur_page>1</cur_page><total_page>200</total_page></BODY><Array_List><Credit_No>C090323</Credit_No><Pay_Project>4</Pay_Project><Pyr_ACMUnAc_Nm>安阳营业部</Pyr_ACMUnAc_Nm><Pyr_ACMUnAcNo>1300000002121</Pyr_ACMUnAcNo><Tamt>550.99</Tamt><Btch_Tdnum>50</Btch_Tdnum><Cst_Inpt_Dt>201405120910</Cst_Inpt_Dt><TDP_Nm>王岩</TDP_Nm><Pcs_St>处理中</Pcs_St></Array_List><Array_List><Credit_No>C090324</Credit_No><Pay_Project>3</Pay_Project><Pyr_ACMUnAc_Nm>安阳营业部</Pyr_ACMUnAc_Nm><Pyr_ACMUnAcNo>1300000002121</Pyr_ACMUnAcNo><Tamt>555.99</Tamt><Btch_Tdnum>150</Btch_Tdnum><Cst_Inpt_Dt>201405120920</Cst_Inpt_Dt><TDP_Nm>主管</TDP_Nm><Pcs_St>交易成功</Pcs_St></Array_List></DOCUMENT>";
      // mResult = XML.toJSONObject((String)mResult).toString();
      // }
    } catch (ParseDataException e) {
      e.printStackTrace();
      throw new ParseDataException();
    } catch (NetworkException e) {
        e.printStackTrace();
      throw new NetworkException();
    } catch (Exception e) {
        e.printStackTrace();
    } finally {

    }

    return mResult;
  }

  protected String getCookies(Context context, String sys) {
    String cookies = null;

    if (Constants.CHANNEL_TYPE_0.equals(sys)) {
      // 个人网银
      cookies = B2CSystem.getCookies();
    } else if (Constants.CHANNEL_TYPE_1.equals(sys)) {
      // 企业网银
      cookies = B2BSystem.getCookies();
    } else if (Constants.CHANNEL_TYPE_2.equals(sys)) {
      // 手机银行
      cookies = MBSSystem.getCookies();
    } else if (Constants.CHANNEL_TYPE_3.equals(sys)) {
      // 网站
      cookies = CCBSystem.getCookies();
    } else if (Constants.CHANNEL_TYPE_JS.equals(sys)) {
      // 无交易码请求交易 JS
      cookies = JSSystem.getCookies();
    } else if (Constants.CHANNEL_TYPE_PIC.equals(sys)) {
      // 无交易码请求交易 pic
      cookies = PICSystem.getCookies();
    } else {
      // 默认
    }

    if (cookies == null) {
      cookies = "";
    }
    return "CCBIBS1=" + cookies;
  }

  public static SYS_TXATTR getSysTxattr() {
    return mManager.mSYS_TXATTR;
  }

  // 公共系统参数方法
  public static HashMap<String, String> getSysPara() {

    return mManager.mSysParas;
  }

  // 业务层下送档板文件信息。
  public void setLocalResponse(HashMap<String, String> localResponse) {
    this.localResponse = localResponse;
  }

  // 返回业务层档板文件内容
  public static HashMap<String, String> getLocalResponse() {
    return mManager.localResponse;
  }

  /**
   * 
   * 初始化系统参数
   * 
   * @param context
   *          上下文
   * @param sqlList
   *          SQL脚本
   * @return void: 返回类型
   */
  public void initConfig(Context context, List<String> sqlList, int db_version, HashMap<String, String> localResponse) {
    SharedPreferences preferences = context.getSharedPreferences("INITDB_TX", Context.MODE_PRIVATE);
    // 设置档板文件
    PlatformManager.getInstance().setLocalResponse(localResponse);

    boolean exeSuccess = preferences.getBoolean("exeSuccess", false);
    int mDbver = preferences.getInt("PLATFORM_DB_VERSION", 1);
    if (mDbver < db_version) {
      preferences.edit().putInt("PLATFORM_DB_VERSION", db_version).commit();
    }
    
//    if (!exeSuccess && sqlList != null) {
    if(sqlList!=null){
      mManager.mDB = new DBUtil(context, sqlList);
      boolean result = mManager.mDB.initSystemDB();
      preferences.edit().putBoolean("exeSuccess", result).commit();
      mSysParas = mManager.mDB.iniSys_paras();
      sys_TXATTR_map = mManager.mDB.iniSys_txattrs();
    }

  }

  // 设置线程池
  public void runThread(Runnable command) {
    Platform_ThreadPools pools = Platform_ThreadPools.getInstance();
    pools.submit(command);
  }

  /**
   * 获取数据库sql参数
   * 
   * @param context
   *          上下文参数
   * @param channel_url
   *          渠道关键字
   * @return
   */
  public String getSYSPARAS(Context context, String channel_url) {

    String str = "";
    // 获取
    if (mManager.mAppInfo == null) {
      mManager.mAppInfo = AppInfo.getAppInfo(context);
      BaseSystem.mAppInfo = mManager.mAppInfo;
    }

    if (mManager.mDB == null) {
      MbsLogManager.logD("init DB....");
      mManager.mDB = new DBUtil(context);
      mSysParas = mManager.mDB.iniSys_paras();
      sys_TXATTR_map = mManager.mDB.iniSys_txattrs();
    }

    str = (channel_url == null ? "" : mSysParas.get(channel_url));

    return str;
  }

}
