/**   
* @Package     : com.ccb.mobile.platform.system
* @Copyright   : @版权所有 中国建设银行版权所有
* @Description : TODO(用一句话描述该文件做什么)
* Administrator   
* 2014-4-25
* @version     : v1.0   
*/

package com.ccb.mobile.platform.system;

import java.util.HashMap;

import org.apache.http.client.CookieStore;
import org.apache.http.cookie.Cookie;

import android.content.Context;
import android.text.TextUtils;

import com.ccb.mobile.platform.Constants;
import com.ccb.mobile.platform.exception.NetworkException;
import com.ccb.mobile.platform.http.HttpClient;
import com.ccb.mobile.platform.http.HttpException;
import com.ccb.mobile.platform.http.Response;
import com.ccb.mobile.platform.utils.MbsLogManager;

/**
 * 生成Ebs(网银)系统,负责处理各种Ebs规则
 * @ClassName    : EbsSystem
 * @author       : LiangYJ
 * @date         : 2014-4-25
 * 
 */
public class JSSystem extends BaseSystem<Object> {
	private static final HashMap<String, String> HEADER = new HashMap<String, String>(6);
	private static final String USER_AGENT = "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1; Trident/4.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; InfoPath.2)";
	private static final String ACCEPT = "image/jpeg, application/x-ms-application, image/gif, application/xaml+xml, image/pjpeg, application/x-ms-xbap, application/vnd.ms-excel, application/vnd.ms-powerpoint, application/msword, */*";
	private static final String CONNECTION = "Keep_Alive";
	private static final String ACCEPT_LANGUAGE = "zh-cn,zh;q=0.5";
	private static final String ACCEPT_ENCODING = "gzip, deflate";
	private static final String REFERER = "http://www.ccb.com/cn";
	private static CookieStore mCookieStore;
	private static JSSystem jsSystem;
	
	static {
		HEADER.put("user-agent", USER_AGENT);
		HEADER.put("accept", ACCEPT);
		HEADER.put("Proxy-Connection", CONNECTION);
		HEADER.put("Accept-Language", ACCEPT_LANGUAGE);
		HEADER.put("Accept-Encoding", ACCEPT_ENCODING);
		HEADER.put("Referer", REFERER);
	}
	
	public JSSystem(Context context) {
		super(context);
	}
	
	/**
	 * 无交易码交易，返回请求串
	* @param params
	* @return
	* @return String: 返回类型
	 */
	public String getParamsUrl(String url,HashMap<String, String> params){
		StringBuilder sb = new StringBuilder();
		if(params != null && params.size() > 0){
			String value = null;
			for(String key : params.keySet()){
				value = (String)params.get(key);
			}
//			MbsLogManager.logD("------线程号----参数-------:"+Thread.currentThread().getId()+"--"+params);
			if(!"".equals(url)){
				sb.append(url).append("/").append(value);
			}else{
				sb.append(value);
			}
		}
		return sb.toString();
	}

	@Override
	protected String fectchFromCache() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	protected boolean isCache() {
		// TODO Auto-generated method stub
		return false;
	}
	
	public String sendRequestForPic(){
		
		return null;
	}

	public static JSSystem getJSSystem(Context context,HashMap<String,String> params){
		if(jsSystem == null){
			jsSystem = new JSSystem(context);
		}
		
		return jsSystem;
	}

	@Override
	public String request_String(String url, HashMap<String, String> params, final String chartSet,final boolean isCallIso_Gbk){
		String chartset_JS = "";
		if(params != null && params.size() > 0){
			chartset_JS = params.get("CharSet");
			if(TextUtils.isEmpty(chartset_JS)){
				chartset_JS = chartSet;
			}
		}
		MbsLogManager.logD("chartset_JS::::::::::::::"+chartset_JS);
		HttpClient httpClient = getHttpClient(chartset_JS);
		setHttpClient(httpClient);
		String request_url = "";
		httpClient.setHeaders(HEADER);
		
		if(mCookieStore!=null){
			httpClient.setCookie(mCookieStore);
		}
		Response response = null;
		try {
			request_url = getParamsUrl(url,params);
			response = httpClient.get(request_url);
		} catch (HttpException e) {
			e.printStackTrace();
			throw new NetworkException(Constants.EXCEPTION_NETWORK_ERROR);
		}
		String result = null;

		if(response != null){
			try {
				result = response.asString(chartset_JS, isCallIso_Gbk);
				mCookieStore = httpClient.getCookie();
			}catch (Exception e) {
				e.printStackTrace();
				throw new NetworkException(Constants.EXCEPTION_NETWORK_ERROR);
			}
		}else{
			throw new NetworkException(Constants.EXCEPTION_NETWORK_ERROR);
		}
		MbsLogManager.logD("No_TxcodeSystem sendRequest " + result);
		return result;
	}
	
  public static String getCookies() {
    if (mCookieStore == null) {
      return "";
    } else {
      for (Cookie cookie : mCookieStore.getCookies()) {
        if ("CCBIBS1".equals(cookie.getName()))
          return cookie.getValue();
      }
      return "";
    }
  }
	
}
