/**   
* @Package     : com.ccb.mobile.platform.system
* @Copyright   : @版权所有 中国建设银行版权所有
* @Description : TODO(用一句话描述该文件做什么)
* Administrator   
* 2014-4-25
* @version     : v1.0   
*/

package com.ccb.mobile.platform.system;

import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.apache.http.Header;
import org.apache.http.client.CookieStore;
import org.apache.http.cookie.Cookie;

import android.content.Context;
import android.text.TextUtils;
import android.util.Log;

import com.ccb.mobile.platform.Constants;
import com.ccb.mobile.platform.PlatformManager;
import com.ccb.mobile.platform.PlatformSafeManager;
import com.ccb.mobile.platform.bean.AppInfo;
import com.ccb.mobile.platform.bean.SYS_TXATTR;
import com.ccb.mobile.platform.exception.NetworkException;
import com.ccb.mobile.platform.http.HttpClient;
import com.ccb.mobile.platform.http.HttpException;
import com.ccb.mobile.platform.http.Response;
import com.ccb.mobile.platform.utils.MbsLogManager;
import com.ccb.mobile.platform.utils.PlatformUtils;
import com.google.gson.Gson;

/**
 * 生成Ebs(网银)系统,负责处理各种MBS规则
 * @ClassName    : EbsSystem
 * @author       : LiangYJ
 * @date         : 2014-4-25
 * 
 */
public class MBSSystem extends BaseSystem<Object> {
	private static final HashMap<String, String> HEADER = new HashMap<String, String>(6);
	private static CookieStore mCookieStore;
	private static MBSSystem ccbSystem;
	public static MbsRequestHeader mMbsRequestHeader = new MbsRequestHeader();
	public static String mMbsTxcode ;

	/** 通讯请求参数 */
	protected HashMap<String, String> params;
	
	public MBSSystem(Context context) {
		super(context);
	}

	@Override
	public String request_String(String url, HashMap<String, String> txParams,final String chartSet,final boolean isCallIso_Gbk) {
		String result = null;
		if(isCache()){//读取档板信息
			result = fectchFromCache();
		}else{
			SYS_TXATTR sys_TXATTR = PlatformManager.getSysTxattr();
			mMbsTxcode = sys_TXATTR.getTxcode();
			
			HttpClient httpClient = getHttpClient(chartSet);
			setHttpClient(httpClient);
			createMbsHeader();
			httpClient.setHeaders(HEADER);
			if(mCookieStore != null){
				httpClient.setCookie(mCookieStore);
			}
			//传递的公共参数
			final String agent = PlatformManager.getSysPara().get("MBS_AGENT");
			final String version = mAppInfo.mVersionName;
			final String device = mAppInfo.mModel;
			final String platform = mAppInfo.mPlatform;
			final String local = "ZH_cn";
			final String ext = "";
			final String mbs_Version = PlatformManager.getSysPara().get("MBS_VERSION");
			
			String requestMessage = createMbsRequestMessage(mMbsTxcode, "id0", mbs_Version, "", txParams);
			
			final String jsonHeader = "{\"header\":{\"agent\":\"{%1$s}\",\"version\":\"{%2$s}\",\"device\":\"{%3$s}\",\"platform\":\"{%4$s}\",\"local\":\"{%5$s}\",\"ext\":\"{%6$s}\"},"
						 .replace("{%1$s}", agent).replace("{%2$s}", version).replace("{%3$s}", device)
						 .replace("{%4$s}", platform).replace("{%5$s}", local).replace("{%6$s}", ext);
			final String jsonRequest = "\"request\":[" + requestMessage + "]}";
			
			MbsLogManager.logD("sendMbsRequest Json " + jsonHeader + jsonRequest);
			
			final String cs_txcodes = PlatformManager.getSysPara().get("MBS_CS_CHECK");
	
			HashMap<String, String> paramsMap = null;
//			Header[] responseHeaders = getResponseHeaders();
//			if(responseHeaders != null){
//				for (Header header : responseHeaders) {
//					if("HEAD_SKEY".equalsIgnoreCase(header.getName())){
//						if(!TextUtils.isEmpty(header.getValue())){
//							com.ccb.mobile.platform.Constants.MBS_SKEY = header.getValue();
//						}
//					}else if("HEAD_MBSKEY".equalsIgnoreCase(header.getName())){
//						if(!TextUtils.isEmpty(header.getValue())){
//							com.ccb.mobile.platform.Constants.MBS_MBSKEY = header.getValue();
//						}
//					}else if("HEAD_USERID".equalsIgnoreCase(header.getName())){
//						if(!TextUtils.isEmpty(header.getValue())){
//							com.ccb.mobile.platform.Constants.MBS_USERID = header.getValue();
//						}
//					}else if("HEAD_BRANCHID".equalsIgnoreCase(header.getName())){
//						if(!TextUtils.isEmpty(header.getValue())){
//							com.ccb.mobile.platform.Constants.MBS_BRANCHID = header.getValue();
//						}
//					}
//				}
//			}

			//手机银行
			if(cs_txcodes.contains(mMbsTxcode)){
				//可信交易组合参数
				//MBS服务器用Gson解析,这里用Gson组装
				HashMap<String, String> params = new HashMap<String, String>();
				params.put("JSON", jsonHeader + jsonRequest);
				params.put("SKEY", com.ccb.mobile.platform.Constants.MBS_SKEY);
				params.put("MBSKEY", com.ccb.mobile.platform.Constants.MBS_MBSKEY);
				params.put("USERID", com.ccb.mobile.platform.Constants.MBS_USERID);
				params.put("BRANCHID", com.ccb.mobile.platform.Constants.MBS_BRANCHID);
				Gson gson = new Gson();
				String json = gson.toJson(params);
				
				paramsMap = new HashMap<String, String>(3);
				paramsMap.put("JSON", PlatformSafeManager.getEncryptString(json));
				paramsMap.put("SIGN", PlatformSafeManager.getSignString(json));
				paramsMap.put("TXCODES", mMbsTxcode);
			}else{
				//普通交易
	            paramsMap = new HashMap<String, String>(5);
				paramsMap.put("JSON", jsonHeader + jsonRequest);
				
				paramsMap.put("SKEY", com.ccb.mobile.platform.Constants.MBS_SKEY);
				paramsMap.put("MBSKEY", com.ccb.mobile.platform.Constants.MBS_MBSKEY);
				paramsMap.put("USERID", com.ccb.mobile.platform.Constants.MBS_USERID);
				paramsMap.put("BRANCHID", com.ccb.mobile.platform.Constants.MBS_BRANCHID);
			}
	
			Response response = null;
			try {
				//Get方法
				if(sys_TXATTR.getSubmitType().equalsIgnoreCase(METHOD_GET)){
					if(TextUtils.isEmpty(sys_TXATTR.getUrl())){
						String request_url = getParamsUrl(url, paramsMap);
						response = httpClient.get(request_url);
					}else{
						String request_url = getParamsUrl(url+sys_TXATTR.getUrl(), paramsMap);
						response = httpClient.get(request_url);
					}
				//Post方法	
				}else if(sys_TXATTR.getSubmitType().equalsIgnoreCase(METHOD_POST)){
					response = httpClient.post(url, getBasicNameValuePairs(paramsMap));
				}
				
			} catch (HttpException e) {
				if(MbsLogManager.IS_DEBUG){
					e.printStackTrace();
				}
				throw new NetworkException(Constants.EXCEPTION_NETWORK_ERROR);
			}
			if(response != null){
				try {
					result = response.asString(chartSet,isCallIso_Gbk);
					result = PlatformUtils.subStr(result);
					mCookieStore = httpClient.getCookie();
				}catch (Exception e) {
					if(MbsLogManager.IS_DEBUG){
						e.printStackTrace();
					}
					throw new NetworkException(Constants.EXCEPTION_NETWORK_ERROR);
				}
			}else{
				throw new NetworkException(Constants.EXCEPTION_NETWORK_ERROR);
			}
		}
		
		MbsLogManager.logD("MBSSystem sendRequest result:" + result);
		return result;
	}
	
	/**
	 * 
	* createMbsRequestMessage
	* @param txcode 交易码
	* @param id 子交易唯一标示。可以通过关联标志关联起来。
	* @param version 当前调用接口的版本。如果不填写，则缺省为最新版本
	* @param preassociated 关联标志。用于多交易组包，表示该交易依赖于哪个交易。缺省为空。
	* @param params 请求参数
	* @param 设定文件
	* @return String 返回类型
	 */
	private String createMbsRequestMessage(String txcode,String id,String version,String preassociated,HashMap<String, String> params){
		final String paramFormat = "\"{%1$s}\":\"{%2$s}\"";
		StringBuilder paramsb = new StringBuilder();
		Iterator<String> iterator = params.keySet().iterator();
		int last = params.size() - 1;
		int index = 0;
		while (iterator.hasNext()) {
			String key = iterator.next();
			String value = "";
			if("USERID".equalsIgnoreCase(key)){
				value = Constants.MBS_USERID;
			}else if("MBSKEY".equalsIgnoreCase(key)){
				value = Constants.MBS_MBSKEY;
			}else if("SKEY".equalsIgnoreCase(key)){
				value = Constants.MBS_SKEY;
			}else{
				value = params.get(key);
			}

			if(index == last){
				paramsb.append(paramFormat.replace("{%1$s}", key).replace("{%2$s}", value));
			}else{
				paramsb.append(paramFormat.replace("{%1$s}", key).replace("{%2$s}", value)).append(",");
			}
			index++;
		}
		
		StringBuilder rsb = new StringBuilder();
		rsb.append("{\"txCode\":\"").append(txcode).append("\",\"id\":\"")
		   .append(id).append("\",\"version\":\"").append(version)
		   .append("\",\"preassociated\":\"").append(preassociated)
		   .append("\",\"params\":{").append(paramsb.toString()).append("}}");
		String head_json = rsb.toString();
		MbsLogManager.logD("MBSSystem createMbsRequestMessage: " + head_json);
		return head_json;
	}
	
	/**
	 * 创建手机银行请求参数
	* @return HashMap<String,String>: 返回类型
	 */
	protected HashMap<String, String> createMbsHeader() {
		HEADER.put("MBC-User-Agent", mMbsRequestHeader.getMBC_User_Agent(mAppInfo));
		HEADER.put("UserToken", mMbsRequestHeader.mUserToken);
		HEADER.put("MBC-User-Info", mMbsRequestHeader.mMBC_User_Info);
		return HEADER;
	}
	@Override
	protected String fectchFromCache() {
		String txcode = PlatformManager.getSysTxattr().getTxcode();
		String result = PlatformManager.getLocalResponse() != null ? PlatformManager.getLocalResponse().get(txcode):"";
		return result;
	}

	@Override
	protected boolean isCache() {
		String txcode = PlatformManager.getSysTxattr().getTxcode();
		if(PlatformManager.getLocalResponse() != null ){
			if(!TextUtils.isEmpty(PlatformManager.getLocalResponse().get(txcode))){
				return true;
			}
		}
		return false;	
	}
	

	/**
	*　1.网络请求类，采用单例模式。
	*　2.请求参数每次都必须重新赋值
	* This isCCBSystem.java class 
	* @param context 交易上下文
	* @param paras　交易请求参数
	* @return CCBSystem: 返回类型
	 */
	public static MBSSystem getMBSSystem(Context context,HashMap<String,String> paras){
		if(ccbSystem == null){
			ccbSystem = new MBSSystem(context);
		}
		return ccbSystem;
	}
	
	/**
	 * 组装通讯参数 key1=value1&key2=value2&...&keyN=valueN 所有的key
	 * 和value经过URLEncoder.encode(key or value,"utf-8")处理
	 * 
	 * @param map
	 * @return 组装后的参数
	 */
	public static String assembleParams(HashMap<String, String> map) {
		if (map == null || map.size() == 0)
			return "";
		StringBuffer buffer = new StringBuffer(512);
		for (Map.Entry<String, String> entry : map.entrySet()) {
			String key = entry.getKey();
			if (key != null) {
				try {
					String value = entry.getValue() == null ? "" : entry.getValue();
					value = URLEncoder.encode(value, HttpClient.UTF_8);
					buffer.append(key).append(Constants.ONE_EQUAL).append(value).append(Constants.YU);
				} catch (Exception e) {
					MbsLogManager.logD(e.toString());
				}
			}
		}
		// 删除最后的一个&
		if (buffer.length() > 0) {
			buffer.deleteCharAt(buffer.length() - 1);
		}
		return buffer.toString();
	}
	
	public static class MbsRequestHeader{
		public String mMBS_User_Agent = "";
		public String mUserToken = "";
		public String mMBC_User_Info = "";
		
		public String getMBC_User_Agent(AppInfo appInfo){
			StringBuilder sb = new StringBuilder();
			sb.append("PADCCB/AndroidPAD/").append(appInfo.mSysVersionName)
			  .append("/").append(appInfo.mVersionName).append("/").append(appInfo.mVersionCode)
			  .append("/").append(appInfo.mDeviceId).append("/").append(appInfo.mPageVersion)
			  .append("/").append(appInfo.mResolution).append("/");
			return sb.toString();
		}
		
		@Override
		public String toString() {
			return "MbsRequestHeader [mMBS_User_Agent=" + mMBS_User_Agent
					+ ", mUserToken=" + mUserToken + ", mMBC_User_Info="
					+ mMBC_User_Info + "]";
		}
		
	}
	
  public static String getCookies() {
    if (mCookieStore == null) {
      return "";
    } else {
      for (Cookie cookie : mCookieStore.getCookies()) {
        if ("CCBIBS1".equals(cookie.getName()))
          return cookie.getValue();
      }
      return "";
    }
  }
	
}
