/*
 *@Package     :PriorityThreadFactory.java
 *@classes     :com.ccb.mobile.android.ThreadPool.PriorityThreadFactory 
 *@Copyright   : Administrator
 *@version     : v1.0 
 */
package com.ccb.mobile.platform.threadpool;

import java.util.concurrent.ThreadFactory;
import java.util.concurrent.atomic.AtomicInteger;

/**
 *@classes     :com.ccb.mobile.android.ThreadPool.PriorityThreadFactory 
 *@Description :TODO(Thread优先级。)
 *@author      :Johnli <br/>
 *create at 2014-7-10 下午2:19:34
 *modify: 内容              by:
 *modify date:日期
 */
public class Platform_PriorityThreadFactory implements ThreadFactory {
	private final String mName;  
    private final int mPriority;  
    private final AtomicInteger mNumber = new AtomicInteger();  
      
    public Platform_PriorityThreadFactory(String name, int priority) {  
        mName = name;// 线程池的名称  
        mPriority = priority;//线程池的优先级  
    }  
    
    @Override  
    public Thread newThread(Runnable r) {  
        return new Thread(r, mName +"-"+mNumber.getAndIncrement()){  
            @Override  
            public void run() {  
                // 设置线程的优先级  
            	android.os.Process.setThreadPriority(mPriority);
                super.run();  
            }  
        };  
    }  
}
